%if 0%{?fedora}
%global with_python3 1
%endif

%global with_check 1

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%global python2_version 2.6
%endif

%if 0%{?rhel} && 0%{?rhel} > 6
%global with_python3 0
%{!?python2_shortver: %global python2_shortver %(%{__python2} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%{!?python3_shortver: %global python3_shortver %(%{__python3} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%endif

##  Filtering of private libraries 
%global _privatelibs  ^%{python_sitearch}/prody/.*\\.so$
%global __provides_exclude_from ^(%{_privatelibs})$
%global __requires_exclude_from ^(%{_privatelibs})$

Name: ProDy
Summary: Application for protein structure, dynamics and sequence analysis
Version: 1.8.2
Release: 1%{?dist}
License: GPLv3+
Group: Applications/Engineering
URL: http://www.csb.pitt.edu/ProDy
Source0: https://github.com/prody/ProDy/archive/v%{version}.tar.gz/%{name}-%{version}.tar.gz

##Scipy and some related dependent packages are not available on PPC64
%if 0%{?fedora} < 24
ExcludeArch: ppc64
%endif

BuildRequires: python2-devel
BuildRequires: python-nose
BuildRequires: scipy
BuildRequires: python-biopython
BuildRequires: numpy
BuildRequires: python-matplotlib
BuildRequires: python-unittest2

Requires: scipy
Requires: python-biopython

## Explicit library require for using plotting functions
Requires: python-matplotlib

### Pyparsing is used to define the atom selection grammar
### Biopython KDTree package and pairwise2 module are used for distance based
## atom selections and pairwise sequence alignment, respectively.
#
### argparse is used to implement applications and provided for
## compatibility with Python 2.6.
%if 0%{?rhel}
BuildRequires: python-argparse
BuildRequires: python-unittest2
BuildRequires: pyparsing
Requires: python-argparse
Requires: pyparsing
Requires: python-biopython
Requires: ipython, pyparsing
%else
Requires: python-biopython
Requires: python-ipython
Requires: pyparsing
%endif

%description
ProDy is a free and open-source Python package for protein structure, dynamics,
and sequence analysis.  It allows for comparative analysis and modeling of 
protein structural dynamics and sequence co-evolution.  Fast and flexible ProDy
API is for interactive usage as well as application development.  ProDy also  
comes with several analysis applications and a graphical user interface for 
visual analysis. 
- Visit http://www.csb.pitt.edu/ProDy/ -

%package -n python2-%{name}
Summary: Application for protein structure, dynamics and sequence analysis
%{?python_provide:%python_provide python2-%{name}}
Provides: ProDy = 0:%{version}-%{release}
Requires: scipy
Requires: python-biopython

## Explicit library require for using plotting functions
Requires: python-matplotlib

### Pyparsing is used to define the atom selection grammar
### Biopython KDTree package and pairwise2 module are used for distance based
## atom selections and pairwise sequence alignment, respectively.
#
### argparse is used to implement applications and provided for
## compatibility with Python 2.6.
%if 0%{?rhel}
BuildRequires: python-argparse
BuildRequires: python-unittest2
BuildRequires: pyparsing
Requires: python-argparse
Requires: pyparsing
Requires: python-biopython
Requires: ipython, pyparsing
%else
Requires: python-biopython
Requires: python-ipython
Requires: pyparsing
%endif

%description -n python2-%{name}
This is ProDy Python2 package for protein structure, dynamics,
and sequence analysis.  It allows for comparative analysis and modeling of 
protein structural dynamics and sequence co-evolution.  Fast and flexible ProDy
API is for interactive usage as well as application development.  ProDy also  
comes with several analysis applications and a graphical user interface for 
visual analysis. 
- Visit http://www.csb.pitt.edu/ProDy/ -

%if 0%{?with_python3}
%package -n python3-%{name}
Summary: Application for protein structure, dynamics and sequence analysis

BuildRequires: python3-devel
BuildRequires: python3-nose
BuildRequires: python3-urllib3
BuildRequires: python3-scipy
BuildRequires: python3-numpy
BuildRequires: python3-matplotlib
BuildRequires: python3-unittest2
BuildRequires: python3-biopython

Requires: python3-scipy
Requires: python3-biopython
Requires: python3-ipython
Requires: python3-pyparsing

## Explicit library require for using plotting functions
Requires: python3-matplotlib
%{?python_provide:%python_provide python3-%{name}}

%description -n python3-%{name}
This is ProDy Python3 package for protein structure, dynamics,
and sequence analysis.  It allows for comparative analysis and modeling of 
protein structural dynamics and sequence co-evolution.  Fast and flexible ProDy
API is for interactive usage as well as application development.  ProDy also  
comes with several analysis applications and a graphical user interface for 
visual analysis. 
- Visit http://www.csb.pitt.edu/ProDy/ -
%endif # with_python3

%prep
%setup -qc
mv %{name}-%{version} python2

pushd python2
## Removing bundled files
rm prody/atomic/pyparsing*
rm -rf prody/KDTree
rm prody/proteins/pairwise2.py prody/proteins/cpairwise2.c
rm prody/apps/argparse.py
popd

%if 0%{?with_python3}
cp -a python2 python3
%endif # with_python3

%build
pushd python2
CFLAGS="$RPM_OPT_FLAGS -Wl,-z,relro -Wl,-z,now" %{__python2} setup.py build --executable="%{__python2} -s"
popd

%if 0%{?with_python3}
pushd python3
CFLAGS="$RPM_OPT_FLAGS -Wl,-z,relro -Wl,-z,now" %{__python3} setup.py build --executable="%{__python3} -s"
popd
%endif # with_python3

%install
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if 0%{?with_python3}
pushd python3
CFLAGS="%{optflags}" %{__python3} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT

##Avoiding collisions between the python 2 and python 3 stacks
mv $RPM_BUILD_ROOT%{_bindir}/prody $RPM_BUILD_ROOT%{_bindir}/python%{python3_version}-prody
mv $RPM_BUILD_ROOT%{_bindir}/evol $RPM_BUILD_ROOT%{_bindir}/python%{python3_version}-evol

mkdir exe && cd exe
for i in prody-3 prody-%{python3_version}; do
  touch -r $RPM_BUILD_ROOT%{_bindir}/python%{python3_version}-prody $i
  install -p $i $RPM_BUILD_ROOT%{_bindir}
  ln -sf %{_bindir}/python%{python3_version}-prody $RPM_BUILD_ROOT%{_bindir}/$i
done

for i in evol-3 evol-%{python3_version}; do
  touch -r $RPM_BUILD_ROOT%{_bindir}/python%{python3_version}-evol $i
  install -p $i $RPM_BUILD_ROOT%{_bindir}
  ln -sf %{_bindir}/python%{python3_version}-evol $RPM_BUILD_ROOT%{_bindir}/$i
done
cd ..
popd
##
%endif

pushd python2
CFLAGS="%{optflags}" %{__python2} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT

##Avoiding collisions between the python 2 and python 3 stacks
cp -p $RPM_BUILD_ROOT%{_bindir}/prody $RPM_BUILD_ROOT%{_bindir}/python%{python2_version}-prody
cp -p $RPM_BUILD_ROOT%{_bindir}/evol $RPM_BUILD_ROOT%{_bindir}/python%{python2_version}-evol

mkdir exe && pushd exe
for i in prody prody-2 prody-%{python2_version}; do
  touch -r $RPM_BUILD_ROOT%{_bindir}/python%{python2_version}-prody $i
  install -p $i $RPM_BUILD_ROOT%{_bindir}
  ln -sf %{_bindir}/python%{python2_version}-prody $RPM_BUILD_ROOT%{_bindir}/$i
done

for i in evol evol-2 evol-%{python2_version}; do
  touch -r $RPM_BUILD_ROOT%{_bindir}/python%{python2_version}-evol $i
  install -p $i $RPM_BUILD_ROOT%{_bindir}
  ln -sf %{_bindir}/python%{python2_version}-evol $RPM_BUILD_ROOT%{_bindir}/$i
done
popd
popd
##

%if 0%{?with_check}
%ifnarch s390 s390x
%check
##Some tests skipped for missing internet connections on koji
##https://github.com/prody/ProDy/issues/248
##https://github.com/prody/ProDy/issues/300
pushd python2/build/scripts-%{python2_version}
PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitearch} nosetests --verbosity=2 \
 -e test_select.py \
 -e test_enms.py \
%if 0%{?rhel} && 0%{?rhel} < 7
 -e test_frame.py \
 -e test_dcdfile.py \
 -e test_analysis.py \
 -e test_kdtree.py \
 -e test_ensemble.py \
 -e test_prody_anm.py \
 -e test_prody_gnm.py \
 -e test_prody_catdcd.py \
 -e test_prody_pca.py \
 -e test_prody_examples.py \
%endif
 -w $RPM_BUILD_ROOT%{python2_sitearch}/prody/tests --tests prody -a '!slow'
popd

%if 0%{?with_python3}
pushd python3/build/scripts-%{python3_version}
PYTHONPATH=$RPM_BUILD_ROOT%{python3_sitearch} nosetests-%{python3_version} --verbosity=2 \
 -e test_atomic.py \
 -e test_pdbfile.py \
 -e test_measure.py \
 -e test_wwpdb.py \
 -e test_enms.py \
 -e test_localpdb.py \
 -e test_msafile.py \
 -e test_pathtools.py \
 -e test_select.py \
 -e test_dcdfile.py \
 -w $RPM_BUILD_ROOT%{python3_sitearch}/prody/tests --tests prody -a '!slow'
popd
%endif
%endif
%endif

%files -n python2-%{name}
%{!?_licensedir:%global license %doc}
%doc python2/README.rst
%license python2/LICENSE.rst
%{_bindir}/prody
%{_bindir}/prody-2
%{_bindir}/prody-%{python2_version}
%{_bindir}/python%{python2_version}-prody
%{_bindir}/evol
%{_bindir}/evol-2
%{_bindir}/evol-%{python2_version}
%{_bindir}/python%{python2_version}-evol
%{python2_sitearch}/prody/
%{python2_sitearch}/%{name}-*.egg-info

%if 0%{?with_python3}
%files -n python3-%{name}
%license python3/LICENSE.rst
%doc python3/README.rst
%{_bindir}/prody-3
%{_bindir}/prody-%{python3_version}
%{_bindir}/python%{python3_version}-prody
%{_bindir}/evol-3
%{_bindir}/evol-%{python3_version}
%{_bindir}/python%{python3_version}-evol
%{python3_sitearch}/prody/
%{python3_sitearch}/%{name}-*.egg-info
%endif

%changelog
* Mon Jul 11 2016 Antonio Trande <sagitterATfedoraproject.org> - 1.8.2-1
- Update to 1.8.2

* Sat May 14 2016 Antonio Trande <sagitterATfedoraproject.org> - 1.8.1-1
- Update to 1.8.1
- Drop old patch

* Sun Feb 14 2016 Antonio Trande <sagitterATfedoraproject.org> - 1.7.1-6
- Rebuilt after GCC6 update
- Test enabled

* Sun Feb 14 2016 Antonio Trande <sagitterATfedoraproject.org> - 1.7.1-5
- Python2 package renamed
- Test disabled

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.7.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Dec 10 2015 Antonio Trande <sagitterATfedoraproject.org> - 1.7.1-3
- SPEC file adapted to recent guidelines for Python

* Sun Nov 22 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.7.1-2
- Original Python2 'prody' and 'evol' binary files preserved
- Skip tests that are slow

* Fri Nov 13 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.7.1-1
- Update to 1.7.1
- Added scipy as BR package
- Set CFLAGS for hardened builds

* Sun Sep 27 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.6.1-1
- Version changed to 1.6.1
- Some tests excluded on EPEL6
- Tests not entirely ready for Python3

* Sat Sep 26 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.6-2
- Fixed python2_version on EL6

* Fri Sep 25 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.6-1
- Update to 1.6
- Performed tests

* Tue Jun 16 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed May 13 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-7
- PPC64 excluded

* Mon May 04 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-6
- Fixed License tag
- Python3 disabled because of missing BR package

* Mon May 04 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-5
- Rebuild

* Sun May 03 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.5.1-4
- Built with Python3
- Built on EPEL6

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jun 06 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Jan 03 2014 Antonio Trande <sagitter@fedoraproject.org> 1.5.1-1
- Update to 1.5.1

* Mon Nov 25 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.10-1
- Update to 1.4.10

* Sat Nov 16 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.9-1
- Update to 1.4.9
- Remove 'cpairwise2.c' file

* Wed Nov 06 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.8-1
- Re-defined required packages for EPEL
- Update to 1.4.8

* Thu Oct 24 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.6-2
- Defined a python2 macro only for Fedora

* Wed Oct 23 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.6-1
- Update to 1.4.6
- Defined python-argparse required package for EPEL
- Spec file renamed ProDy 
- Defined a python2 macro only for Fedora 

* Sun Sep 15 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.4-3
- Bundled files removed
- Add new required packages (pyparsing, python-biopython)

* Mon Aug 12 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.4-2
- Added python-matplotlib and python-ipython as Requires
- Perform filtering private libraries 
- Fix some 'non-executable-script' warnings
- Add a Python shebang

* Mon Aug 12 2013 Antonio Trande <sagitter@fedoraproject.org> 1.4.4-1
- Initial build
